"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var react_native_1 = require("react-native");
var classnames_1 = __importDefault(require("../../utils/classnames"));
var styles_1 = __importDefault(require("./styles"));
var defaultRenderToken = function (_a, index) {
    var type = _a.type, value = _a.value, properties = _a.properties, children = _a.children;
    var renderWithStyle = function (style) { return (react_1.default.createElement(react_native_1.Text, { key: index, style: style, numberOfLines: 1 }, value ? value : children && children.map(defaultRenderToken))); };
    switch (type) {
        case 'text': {
            return value;
        }
        default: {
            return renderWithStyle(properties.style);
        }
    }
};
var CodeCell = react_1.default.memo(function (props) {
    var text = props.text, tokens = props.tokens, renderToken = props.renderToken, style = props.style, textStyle = props.textStyle, attributes = __rest(props, ["text", "tokens", "renderToken", "style", "textStyle"]);
    var actualRenderToken = renderToken
        ? function (token, index) { return renderToken(token, defaultRenderToken, index); }
        : defaultRenderToken;
    return (react_1.default.createElement(react_native_1.View, __assign({ style: classnames_1.default(styles_1.default.diffCodeCell, style) }, attributes),
        react_1.default.createElement(react_native_1.Text, { style: classnames_1.default(styles_1.default.diffCodeCellText, textStyle), numberOfLines: 1 }, tokens ? (tokens.length ? tokens.map(actualRenderToken) : ' ') : text || ' ')));
});
CodeCell.defaultProps = {
    tokens: null,
};
exports.default = CodeCell;
//# sourceMappingURL=code_cell.js.map