/// <reference types="react" />
import { TextStyle, ViewStyle } from 'react-native';
export interface IChange {
    content?: string;
    isDelete?: boolean;
    isInsert?: boolean;
    isNormal?: boolean;
    lineNumber?: number;
    newLineNumber?: number;
    oldLineNumber?: number;
    type: 'normal' | 'insert' | 'delete';
}
export interface IHunk {
    changes: IChange[];
    content: string;
    isPlain: boolean;
    newLines: number;
    newStart: number;
    oldLines: number;
    oldStart: number;
}
export interface IParseDiffResult {
    hunks: IHunk[];
    newEndingNewLine: boolean;
    newMode: string;
    newPath: string;
    newRevision: string;
    oldEndingNewLine: boolean;
    oldMode: string;
    oldPath: string;
    oldRevision: string;
    type: 'add' | 'delete' | 'modify' | 'rename' | 'copy';
}
export declare type DiffType = 'add' | 'delete' | 'modify' | 'rename' | 'copy';
export declare type Side = 'old' | 'new';
export declare type GutterType = 'default' | 'none' | 'anchor';
export declare type Widgets = Record<string, JSX.Element>;
export declare type Events = Record<string, (arg: any) => any>;
export declare type DiffChildren = (hunks: IHunk[]) => JSX.Element | JSX.Element[];
export interface IGutterOptions {
    change: IChange;
    side: Side;
    inHoverState: boolean;
    textStyle?: TextStyle;
    renderDefault: (style?: TextStyle, textStyle?: ViewStyle) => JSX.Element;
}
